//-----------------------------------------------------------------------
#include "IGhost.h"
#include "INetworkGame.h"
//-----------------------------------------------------------------------
IGhost::IGhost() 
{
  m_iGhostId=-1;
  m_iGhostType=-1;
  m_InitData=NULL;
  m_iLenInitData=0;
  m_iMasterClientId=0;
}
//-----------------------------------------------------------------------
IGhost::IGhost(int t,int id,const unsigned char *d,int l)
{
  m_iGhostType=t;
  m_iGhostId=id;
  m_iLenInitData=l;
  m_iMasterClientId=0;
  m_InitData=new unsigned char[l];
  memcpy(m_InitData,d,l);
}
//-----------------------------------------------------------------------
IGhost::~IGhost()
{
  if (m_Ng != NULL && isGhost())
    m_Ng->removeGhost(this);
  if (m_InitData != NULL)
    delete [](m_InitData);
}
//-----------------------------------------------------------------------
int IGhost::getGhostInitDataSize()
{
  return (m_iLenInitData);
}
//-----------------------------------------------------------------------
const unsigned char *IGhost::getGhostInitData()
{
  return (m_InitData);
}
//-----------------------------------------------------------------------
void IGhost::setNetworkGame(INetworkGame *ng)
{
  m_Ng=ng;
}
//-----------------------------------------------------------------------
void IGhost::sendMessageToMaster(int t,const unsigned char *d,int l)
{
  m_Ng->ghostToMaster(this,t,d,l);
}
//-----------------------------------------------------------------------
// ---------------------------------------------------------- 
// Sylvain Lefebvre - (c) 2002 - Sylvain.Lefebvre@laposte.net
// ----------------------------------------------------------
