// --------------------------------------------------------------
// Author : Sylvain Lefebvre
// Created: 15/07/2002
// --------------------------------------------------------------
#ifndef __MALLOCTYPE_H_
#define __MALLOCTYPE_H_
// --------------------------------------------------------------
#include <list>
// --------------------------------------------------------------
using namespace std;

// --------------------------------------------------------------

#define MALLOCSEGMENT_EQUAL   1
#define MALLOCSEGMENT_INCLUDE 2
// --------------------------------------------------------------
class MAllocSegment
{
public:

  long m_lStart;
  long m_lEnd;
  
  MAllocSegment()
    {
      m_lStart=m_lEnd=0;
    }

  MAllocSegment(long s,long e)
    {
      m_lStart=s;
      m_lEnd=e;
    }

  int include(const MAllocSegment& s) const
    {
//      cerr << m_lStart << " [" <<  s.m_lStart << ' ' 
//	   << s.m_lEnd << "] " << m_lEnd << endl;
      if (s.m_lStart == m_lStart && s.m_lEnd == m_lEnd)
	return (MALLOCSEGMENT_EQUAL);
      else if (s.m_lStart >= m_lStart && s.m_lEnd <= m_lEnd)
	return (MALLOCSEGMENT_INCLUDE);
      else 
	return (0);
    }
  
};
// --------------------------------------------------------------
class MAllocType
{
private:

  static list<MAllocSegment> *s_AllocSegments;
  bool                m_bDynamic;
  bool                m_bChecked;

  void checkDynamic();

  static void allocateStatic();

public:

  MAllocType();

  bool isDynamic() {checkDynamic(); return (m_bDynamic);}
  bool isStatic()  {checkDynamic(); return (!m_bDynamic);}
  void forceDynamic(bool b) {m_bChecked=true; m_bDynamic=b;}

//  void *operator new(size_t); // FIXME: Desactive 16/09/2002
//  void *operator new[](size_t);
};
// --------------------------------------------------------------
#endif
// --------------------------------------------------------------
